using System;

namespace Littlechip.IsNumeric
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox Status;
		private System.Windows.Forms.Button Benchmark;
		private System.Windows.Forms.Button Clear;
		private System.Windows.Forms.ComboBox ConversionMethod;
		private System.Windows.Forms.TextBox InputValue;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.ConversionMethod.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Status = new System.Windows.Forms.TextBox();
			this.Benchmark = new System.Windows.Forms.Button();
			this.Clear = new System.Windows.Forms.Button();
			this.ConversionMethod = new System.Windows.Forms.ComboBox();
			this.InputValue = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// Status
			// 
			this.Status.BackColor = System.Drawing.SystemColors.Control;
			this.Status.Location = new System.Drawing.Point(8, 88);
			this.Status.Multiline = true;
			this.Status.Name = "Status";
			this.Status.ReadOnly = true;
			this.Status.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.Status.Size = new System.Drawing.Size(216, 168);
			this.Status.TabIndex = 3;
			this.Status.Text = "";
			// 
			// Benchmark
			// 
			this.Benchmark.Location = new System.Drawing.Point(152, 32);
			this.Benchmark.Name = "Benchmark";
			this.Benchmark.TabIndex = 4;
			this.Benchmark.Text = "Benchmark";
			this.Benchmark.Click += new System.EventHandler(this.Benchmark_Click);
			// 
			// Clear
			// 
			this.Clear.Location = new System.Drawing.Point(184, 64);
			this.Clear.Name = "Clear";
			this.Clear.Size = new System.Drawing.Size(40, 23);
			this.Clear.TabIndex = 5;
			this.Clear.Text = "Clear";
			this.Clear.Click += new System.EventHandler(this.Clear_Click);
			// 
			// ConversionMethod
			// 
			this.ConversionMethod.Items.AddRange(new object[] {
																													"Regular Expression",
																													"Try ToDouble & Catch",
																													"Try Parse & Catch",
																													"Double.TryParse",
																													"VisualBasic IsNumeric",
																													"Incremental Char"});
			this.ConversionMethod.Location = new System.Drawing.Point(8, 32);
			this.ConversionMethod.Name = "ConversionMethod";
			this.ConversionMethod.Size = new System.Drawing.Size(144, 21);
			this.ConversionMethod.TabIndex = 6;
			// 
			// InputValue
			// 
			this.InputValue.Location = new System.Drawing.Point(80, 8);
			this.InputValue.Name = "InputValue";
			this.InputValue.Size = new System.Drawing.Size(144, 20);
			this.InputValue.TabIndex = 7;
			this.InputValue.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 8;
			this.label1.Text = "Input Value:";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(232, 261);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.InputValue);
			this.Controls.Add(this.Status);
			this.Controls.Add(this.ConversionMethod);
			this.Controls.Add(this.Clear);
			this.Controls.Add(this.Benchmark);
			this.Name = "MainForm";
			this.Text = "IsNumeric Benchmark";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			System.Windows.Forms.Application.Run(new MainForm());
		}

		/// <summary>
		/// Regular expression that tests for numeric value (allows only numbers and one decimal).
		/// </summary>
		public static System.Text.RegularExpressions.Regex IsNumeric = 
			new System.Text.RegularExpressions.Regex(@"^(\d*\.?\d*)$", 
			System.Text.RegularExpressions.RegexOptions.Compiled &
			System.Text.RegularExpressions.RegexOptions.CultureInvariant);

		/// <summary>
		/// Gets whether or not the <i>expression</i> is numeric
		/// using a try-catch block with Convert.ToDouble.
		/// </summary>
		/// <param name="expression">Value to check.</param>
		/// <returns>Whether or not the <i>expression</i> is numeric
		/// using a try-catch block with Convert.ToDouble.</returns>
		public bool TryToDouble(object expression)
		{
			try
			{
				expression = Convert.ToDouble(expression);
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// Gets whether or not the <i>expression</i> is numeric
		/// using a try-catch block with double.Parse.
		/// </summary>
		/// <param name="expression">Value to check.</param>
		/// <returns>Whether or not the <i>expression</i> is numeric
		/// using a try-catch block with double.Parse.</returns>
		public bool TryParse(object expression)
		{
			try
			{
				expression = double.Parse(expression.ToString());
				return true;
			}
			catch
			{
				return false;
			}
		}

		/// <summary>
		/// Gets whether or not the <i>expression</i> is numeric
		/// by checking each character to see if it is a number.
		/// </summary>
		/// <param name="expression">Value to check.</param>
		/// <returns>Whether or not the <i>expression</i> is numeric
		/// by checking each character to see if it is a number.</returns>
		public bool IncrementalChar(string expression) 
		{ 
			bool hasDecimal = false;
			for(int i=0;i<expression.Length;i++) 
			{ 
				// Check for decimal
				if (expression[i] == '.')
				{
					if (hasDecimal) // 2nd decimal
						return false;
					else // 1st decimal
					{
						// inform loop decimal found and continue 
						hasDecimal = true;
						continue;
					}
				}
				// check if number
				if(!char.IsNumber(expression[i])) 
					return false; 
			} 
			return true; 
		} 


		/// <summary>
		/// Clears the status box.
		/// </summary>
		/// <param name="sender">obj</param>
		/// <param name="e">event args</param>
		private void Clear_Click(object sender, System.EventArgs e)
		{
			this.Status.Clear();
		}

		/// <summary>
		/// Executes IsNumeric evaluation depending on the conversion method.
		/// </summary>
		/// <param name="sender">obj</param>
		/// <param name="e">event args</param>
		private void Benchmark_Click(object sender, System.EventArgs e)
		{
			bool isNumeric = false;
			double result;
			System.DateTime start, end;
			start = System.DateTime.Now;
			switch(this.ConversionMethod.SelectedIndex)
			{
				case 0:
					for (int i = 0; i < 100000; i++)
						isNumeric = IsNumeric.IsMatch(this.InputValue.Text);
					break;
				case 1:
					for (int i = 0; i < 100000; i++)
						isNumeric = this.TryToDouble(this.InputValue.Text);
					break;
				case 2:
					for (int i = 0; i < 100000; i++)
						isNumeric = this.TryParse(this.InputValue.Text);
					break;
				case 3:
					for (int i = 0; i < 100000; i++)
						isNumeric = double.TryParse(this.InputValue.Text, 
							System.Globalization.NumberStyles.AllowDecimalPoint, 
							System.Globalization.NumberFormatInfo.CurrentInfo,
							out result);
					break;
				case 4:
					for (int i = 0; i < 100000; i++)
						isNumeric = Microsoft.VisualBasic.Information.IsNumeric(this.InputValue.Text);
					break;
				case 5:
					for (int i = 0; i < 100000; i++)
						isNumeric = this.IncrementalChar(this.InputValue.Text);
					break;
			}
			end = System.DateTime.Now;
			this.Status.Text += "Using " + this.ConversionMethod.SelectedItem.ToString() + ":\r\n" +
				"Test Value: " + this.InputValue.Text + "\r\n" +
				"Is Numeric: " + isNumeric.ToString() + "\r\n" +
				"Start: " + start.ToLongTimeString() + "\r\n" +
				"End: " + end.ToLongTimeString() + "\r\n" +
				"Elapsed: " + end.Subtract(start) + "\r\n\r\n";
		}
	}
}
